//
//  TAPPXMediationInterstitialAd.m
//
//  Created by Tappx on 28/05/15.
//
//

#import "TappxMediationInterstitialAd.h"
#import <TappxFramework/TappxAds.h>

@implementation TappxMediationInterstitialAd

extern BOOL testMode;
static UIViewController* rootVC;

+ (UIViewController *) getRootVC {
    return rootVC;
}
+ (void) setRootVC:(UIViewController *)vc {
    rootVC = vc;
}


@synthesize delegate;

- (void)dealloc {
    if(_tappxInterstitial!=nil){
        _tappxInterstitial=nil;
    }
}

- (void)requestInterstitialAdWithParameter:(NSString *)serverParameter
                                     label:(NSString *)serverLabel
                                   request:(GADCustomEventRequest *)customEventRequest {
    
    NSString* adUnit = serverParameter;

    if ( adUnit != nil ) {
     
        NSArray *elements = [adUnit componentsSeparatedByString:@"|"];
        NSString* key = [elements objectAtIndex: 0];
        
        NSString* isTest = nil;
        if ( [elements count]  > 1 )
            isTest = [elements objectAtIndex: 1];
        
        if ( isTest != nil && [isTest isEqualToString:@"1" ] )
            [TappxFramework addTappxKey:key testMode:YES];
        else {
            [TappxFramework addTappxKey:key];
        }
    }
    else{
        [self.delegate customEventInterstitial:self didFailAd:[NSError errorWithDomain:kGADErrorDomain code:kGADErrorInvalidRequest userInfo:nil]];
        return;
    }
        
    
    _tappxInterstitial = [[TappxInterstitialViewController alloc] initWithDelegate:self];
    [_tappxInterstitial load];
    
}


-(UIViewController*)presentViewController{
    return [TappxMediationInterstitialAd getRootVC];
}

- (void)presentFromRootViewController:(UIViewController *)rootViewController {
    [TappxMediationInterstitialAd setRootVC:rootViewController];
    [_tappxInterstitial show];
}

- (void)tappxInterstitialViewControllerDidFinishLoad:(nonnull TappxInterstitialViewController *)viewController{
    _tappxInterstitial = viewController;
    [self.delegate customEventInterstitialDidReceiveAd:self];
}

- (void)tappxInterstitialViewControllerDidPress:(nonnull TappxInterstitialViewController *)viewController{
    [self.delegate customEventInterstitialWillLeaveApplication:self];
}
- (void)tappxInterstitialViewControllerDidClose:(nonnull TappxInterstitialViewController *)viewController{
    
    [self.delegate customEventInterstitialDidDismiss:self];
}
- (void)tappxInterstitialViewControllerDidFail:(nonnull TappxInterstitialViewController *)viewController withError:(nonnull TappxErrorAd *)error{
    
    NSError* _error = [self convertError:error];
    [self.delegate customEventInterstitial:self didFailAd:_error];
    
    if(_tappxInterstitial!=nil){
        _tappxInterstitial=nil;
    }
}
- (void)tappxInterstitialViewControllerDidAppear:(nonnull TappxInterstitialViewController *)viewController {
    
    [self.delegate customEventInterstitialWillPresent:self];
}

- (void)onTappxInterstitialDismissed:(nonnull TappxInterstitialViewController *)interstitial
{
    NSLog(@"onTappxInterstitialDismissed method");
}

- (NSError *) convertError:(TappxErrorAd *)error {
    
    switch ( error.errorCode ) {
        case DEVELOPER_ERROR:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorInternalError userInfo:nil];
            break;
        case NO_CONNECTION:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorServerError userInfo:nil];
            break;
           
        case NO_FILL:
        default:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorNoFill userInfo:nil];
            break;
    }
}

@end
